import java.util.Scanner;

//ggt(l,m,n) == ggt(l, ggt(m,n))

public class Euklid3 {
	public static void main(String[] args) {
		
		Scanner sc = new Scanner(System.in);
		
		if (sc.hasNextInt()) {
			
			int a = sc.nextInt();
			
			if (sc.hasNextInt()) {
				
				int b = sc.nextInt();
				
				if (sc.hasNextInt()) {
					
					int c = sc.nextInt();
					
					int ergebnis = ggt(a, ggt(b,c));
					
					System.out.println(ergebnis);
					
				}
				
			}
			
		}
		
	}
	
	/**
	* Diese Funktion berechnet den GGT zweier 
	* positiver ganzer Zahlen.
	*
	* @param m eine ganze Zahl größer als Null (m>0). 
	* @param n eine ganze Zahl größer als Null (n>0).
	* @return der GGT der beiden angegebenen Zahlen.
	*/
	public static int ggt(int m, int n) {
		
		if (m == n) return m; // ggt(m, n) == m (== n)
		
		if (m > n) {
			
			//ggt(m, n) == ggt(m - n, n)
			return ggt(m - n, n);
			
		} else { //n > m
			
			//ggt(m, n) == ggt(m, n - m)
			return ggt(m, n - m);
			
		}
		
	}
	
}




