import java.util.Scanner;

//ggt(l,m,n) == ggt(l, ggt(m,n))

public class Euklid4 {
	public static void main(String[] args) {
		
		Scanner sc = new Scanner(System.in);
		int ergebnis = 0;
		
		while(sc.hasNextInt()) {
			
			int a = sc.nextInt();
			
			ergebnis = ggt(a, ergebnis);
			
		}
		
		System.out.println(ergebnis);
		
		
	}
	
	/**
	* Diese Funktion berechnet den GGT zweier 
	* positiver ganzer Zahlen. Sie hat zwei formale Parameter.
	*
	* @param m eine ganze Zahl größer als Null (m>0). 
	* @param n eine ganze Zahl größer als Null (n>0).
	* @return der GGT der beiden angegebenen Zahlen.
	*/
	public static int ggt(int m, int n) {
		
		return (m == 0 || n == 0) ? m+n : m < 0 ? ggt(-m,n) : n < 0 ? ggt(m,-n) : (m == n) ? m : (m > n) ? ggt(m-n, n) : ggt(m, n-m);
		
		
	}
	
}



