
//package collections4;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.Scanner;


public class Collections4 {

    public static void main(String[] args) {
        
        String[] ar = new String[]{
            "Tschechien", "Slowakei", "Ungarn",
            "Slowenien", "Italien", "Schweiz", "Deutschland"
        };
        
        ArrayList<String> arl = new ArrayList<String>();
        for(String s : ar){ arl.add(s); }
        
        arl.add(arl.indexOf("Schweiz"), "Liechtenstein");
        
        System.out.println(arl);
        
        /////////////////////// Iterator ////////////
        
        String lorem = "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.";
        arl.clear();
        
        Scanner sc = new Scanner(lorem);
        while(sc.hasNext()){
        
            String wort = sc.next();
            arl.add(wort);
        }
        
        ListIterator<String> it = arl.listIterator();
        while(it.hasNext()){
        
            if(it.next().length() > 3){
                it.remove();
            }
        
        }
        
        System.out.println(arl);
        
        ////////////////////// SET ////////////////
        
        HashSet<String> hs = new HashSet<String>();
        for(String s : arl){ hs.add(s); }
        hs.clear();
        
        hs = new HashSet<String>(arl);
        
        System.out.println(hs);
        
        /////////////////////// MAP //////////////
        
        HashMap<String, String> hm = new HashMap<String, String>();
        hm.put("Tschechien", "Prag");
        hm.put("Slowakei", "Bratislava");
        hm.put("Ungarn", "Budapest");
        
        System.out.println(hm);
        String Budapest = hm.get("Ungarn");
        System.out.println(Budapest);
        
        hm.put("Ungarn", "Buda");
        
        Budapest = hm.get("Ungarn");
        System.out.println(Budapest);
        System.out.println(hm);
        
        ///////////////////////////////////////////
        
        Person[] leute = new Person[]{
            new Person("Anton"),
            new Person("Berta"),
            new Person("Julius"),
            new Person("Tony")
        };
        
        ArrayList<Person> alLeute = new ArrayList<Person>();
        for(Person p : leute){ alLeute.add(p); }
        
        System.out.println(alLeute);
        
        Person Anton = leute[0];
        alLeute.add(Anton);
        
        Anton.name = "Joseph";
        
        System.out.println(alLeute);
        
        HashSet<Person> hsLeute = new HashSet<Person>(alLeute);
        
        Anton.name = "Tony";        
        
        System.out.println(hsLeute);
        
    }
}

class Person{

    public String name;
    public Person(String name){ this.name = name; }
    
    public String toString(){ return this.name; }
    
    public boolean equals(Object o){
    
        if(o == null || o.getClass() != Person.class){ 
            return false; 
        }
        
        return ((Person)o).name.equals(this.name);
    
    }
    public int hashCode(){ return name.hashCode(); }

}
