/**
* Ein spezieller Telefonbucheintrag, der eine einzelne Person
* repräsentiert, die auch studiert, d.h. eine Matrikelnummer
* hat.
*/
public class StudentEntry extends PersonEntry {

	private int matrNr;
	
	public StudentEntry (String name, String phone, int matrNr) {
		
		super(name, phone);
		this.matrNr = matrNr;
	
	}
	
	public String toString() {
	
		return super.toString() + String.format(", %07d", this.matrNr);
		
	}
	
	public int matrNr() {
	
		return matrNr;
	
	}
	
}
