/**
* Testet die Funktionen der gefragten Klassen. Es können neue
* Testfälle hinzugefügt werden. Der Inhalt dieser Datei wird
* nicht beurteilt.
*/

public class TrainTest {
	public static void main (String [] args) {
		
		Train tgv = new Train(new Locomotive(86, 19.0, 300));
		
		Car pc1 = new PassengerCar(42.0,26.4,54);
		Car pc2 = new PassengerCar(50.0,30.0,66);
		Car pc3 = new PassengerCar(42.0,30.0,56);
		Car dc1 = new DiningCar(42.0,26.4,24,false);
		Car dc2 = new DiningCar(42.0,26.4,24,true);
		
		tgv.add(pc1);
		tgv.add(dc2);
		tgv.add(new PassengerCar(35.0,26.4,32));
		
		System.out.println(tgv.toString());
		/* Ausgabe:
		
		Locomotive 1: 86.0, 19.0, 300
		PassengerCar 2: 42.0, 26.4, 54
		DiningCar 6: 42.0, 26.4, 24, geoeffnet
		PassengerCar 7: 35.0, 26.4, 32
		Hat geöffneten Speisewagen.
		
		*/
		
		Train ice = new Train(new Locomotive(92, 21.0, 450));
		ice.add(pc2);
		ice.add(dc1);
		ice.add(pc3);
		
		System.out.println(ice.toString());
		/* Ausgabe:
		
		Locomotive 8: 92.0, 21.0, 450
		PassengerCar 3: 50.0, 30.0, 66
		DiningCar 5: 42.0, 26.4, 24, geschlossen
		PassengerCar 4: 42.0, 30.0, 56
		
		*/
		
		
		Train ice2 = new Train(new Locomotive(92, 21.0, 450));
		ice2.add(new PassengerCar(50.0,30.0,66));
		ice2.add(new DiningCar(42.0,26.4,24,false));
		ice2.add(new DiningCar(42.0,30.0,56,false));
		
		System.out.println(ice2.toString());
		
		System.out.println(ice.equals(ice2));
		
		
	}
}
