//import java.util.Iterable;
import java.util.Iterator;

public class Train implements Iterable<Car> {
	
	//TODO
	
	private Locomotive head;
	
	public Train(Locomotive head) {
	
		this.head = head;
	
	}
	
	public CarIterator iterator() {
	
		return new CarIterator();
	
	}
	
	public void add(Car toAppend) {
	
		Car findLast = head;
		
		while(findLast.next() != null) {
		
		
			findLast = findLast.next();
		
		}
	
		toAppend.connectTo(findLast);
		
	}
	
	public boolean hasOpenDiningCar() {
		/*
		Car c = head;
		
		while(c != null) {
			
			
			if (c instanceof DiningCar) {
			
				if (((DiningCar)c).open()) {
				
					return true;
				
				}
			
			}
			
			c = c.next();
			
		}
	
		return false;
		*/
		
		return head.next().hasOpenDiningCar();
		
	}
	
	public String toString() {
	
		String out = "";
		
		for(Car c: this) {
		
			out += c.toString() + "\n";
			
			c = c.next();
		
		}
		
		return out + (hasOpenDiningCar() ? "hat geoeffneten Speisewagen." : "");
	
	}
	
	@Override
	public boolean equals(Object o) {
	
		if (o == null || this.getClass() != o.getClass()) {
		
			return false;
		
		}
	
		Train t = (Train) o;
		
		return head.equals(t.head);
		
	}
	
	private class CarIterator implements Iterator<Car> {
	
		private Car next;
		
		CarIterator() {
		
			this.next = Train.this.head;
		
		}
		
		public Car next() {
		
			Car c = next;
			
			next = next.next();
			
			return c;
		
		}
		
		public boolean hasNext() {
		
			return next != null;
		
		}
		
		public void remove() {
		
			throw new UnsupportedOperationException();
		
		}
	
	
	}
	
}
