import java.util.Scanner;

public class BruchRechner3 {
	
	public static void main(String[] args) {
		
		Scanner sc = new Scanner(System.in);
		
		final int maxElements = 10;
	
		Bruch[] stapel = new Bruch[maxElements];
		int top = 0;
		
		while (sc.hasNext()) {
			
			String command = sc.next();
			
			if (command.equals("enter")) {
				
				Bruch b = new Bruch(sc.nextInt(), sc.nextInt());
				stapel[top++] = b;
				
				
			} else if (command.equals("print")) {
			
				for (int i = top - 1; i >= 0; i--) {
				
					Bruch b;
					b = stapel[i];
					
					System.out.println(b.toString());
				
				}
			
				System.out.println();
				
			} else if (command.equals("mult")) {
				
				Bruch b1 = stapel[top-1];
				Bruch b2 = stapel[top-2];
				
				top -= 2;
				
				//stapel[top++] = b1.mult(b2);
				
				/* Aufruf bei Variante 1: */
				b2.mult(b1);
				top++;
				
				/* Aufruf bei Variante 2: 
				stapel[top++] = Bruch.mult(b1,b2);
				*/
				
				
 			} else if (command.equals("reduce")) {
 				/*
				for (int i = 0; i < top; i++) {
				
					//vgl. BruchRechner2
					stapel[i] = stapel[i].reduce();
					
				}
				*/
			
			}	
			
		}
		
	}
	
	/**
	* Diese Funktion berechnet den ggT zweier ganzzahliger Werte.
	* Sie hat zwei formale Parameter.
	*
	* @param m erstes Argument
	* @param n zweites Argument
	* @return der ggT(m,n)
	*/
	public static int ggt(int n, int m) {
		
		return m < 0 ? ggt(-m, n) : n < 0 ? ggt(m, -n) : m == 0 || n == 0 ? m + n : m != n ? m > n ? ggt(m - n, n) : ggt(m, n - m) : m;
			
	}
	
	
	
}
