public class Intervall {

	private Bruch unter;
	private Bruch ober;
	
	/* eindeutiges Objekt vom Typ Intervall. Steht für 
	die leere Menge. Intervallgrenzen sind beliebig, da von außen nicht 
	sichtbar. Ausschlaggebend ist die Identität des Objekts */ 
	public static final Intervall EMPTY = new Intervall(new Bruch(1,2), new Bruch(3,4)); 
	
	
	public Intervall(Bruch unter, Bruch ober) {
	
		this.unter = unter;
		this.ober = ober;
	
	}
	
	public Intervall durchschnitt(Intervall intervall2) {
	
		
		if (this.ober.kleiner(intervall2.unter) || intervall2.ober.kleiner(this.unter) || this == EMPTY || intervall2 == EMPTY) {
		
			return EMPTY;
		
		}
		
		Bruch unter;
		Bruch ober;
		
		unter = this.unter.kleiner(intervall2.unter) ? intervall2.unter : this.unter;
		
		ober = this.ober.kleiner(intervall2.ober) ? this.ober : intervall2.ober;
		
		return new Intervall(unter, ober); //hier gibt es noch was zu verbessern.
	
	}
	
	public String toString() {
		
		if (this == EMPTY) {
		
			return "[]";
		
		}
	
		return "[" + unter.toString() + "," + ober.toString() + "]";
	
	} 

}
