import java.util.HashMap;
import java.util.Scanner;
import java.util.Stack;

public class UPNCalculator {
    
    private Stack<Double> stack;
    //private HashMap<String, Operation> operations;
    private HashMap<String, Factory> operations;
    
    public UPNCalculator(){
        stack = new Stack<Double>();
        /*operations = new HashMap<String, Operation>();
        
        operations.put("+", new AddOperation());
        operations.put("-", new SubtractOperation());
        operations.put("*", new MultiplyOperation());
        operations.put("/", new DivideOperation());*/
        
        operations = new HashMap<String, Factory>();
        operations.put("+", new AddFactory());
    }
    
    /*public void addNewOperation(String symbol, Operation op){
    
        operations.put(symbol, op);
    }*/
    
    public void addNewOperation(String symbol, Factory fc){
    
        operations.put(symbol, fc);
    }
    
    public void enter(String symbol, Scanner sc){
    
        //operations.get(symbol).execute(stack);
        
        // operations.get(symbol).create(sc).execute(stack);
        
        Factory fc = operations.get(symbol);
        Operation op = fc.create(sc);
        op.execute(stack);
        
    }
    
    public void enter(double value){

        stack.push(value);
    }
    
    /**
     * @return Gibt das oberste Element vom Stack zurück
     */
    public String toString(){
        
        return stack.peek().toString();
    
    }
    
    /********************************
     * rigid methods - rationalize!
     ********************************/
    
    /*
    public void add(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x + y;
        stack.push(result);
        
    }
    
    public void subtract(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x - y;
        stack.push(result);
    }
    
    public void multiply(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x * y;
        stack.push(result);
    }
    
    public void divide(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        if(Math.abs(y) < 1E-8){ throw new OperationException("Division durch 0"); }
        
        double result = x - y;
        stack.push(result);
    }
    */
}