public class DiningCar extends PassengerCar {
	
	private boolean open;
	
	public DiningCar(double weight, double length, int seats, boolean open) {
	
		super(weight, length, seats);
		this.open = open;
	
	}
	
	public String toString() {
	
		return super.toString() + ", " + (open ? "geoeffnet" : "geschlossen");
	
	}

	public boolean open() {
	
		return open;
		
	}
	
	@Override
	public boolean hasOpenDiningCar() {
	
		return open || super.hasOpenDiningCar();
	
	}
	
	@Override
	public boolean equals(Object o) {
	
		return super.equals(o) && ((DiningCar) o).open == this.open;
	
	}
	
	
	
}
