import java.util.Scanner;

public class ParkplatzManager {
	
        public static void main(String[] args) {
        	
                
                String befehl = 
                " stellen W16440 1 " +
                " stellen W16440 5 " +                                                 
                " stellen K345L 1  " +                                                 
                " stellen WB3542L 5" + //Platz mit Index 5 bereits belegt             
                " entfernen W16440 " +                                                
                " entfernen SL105W " + //KFZ mit Kennzeichen SL105W nicht abgestellt   
                " stellen G354N 10 " + //Platz mit Index 10 gibt es nicht         
                " belegt 10        " + //Platz mit Index 10 gibt es nicht
                " entfernen W16440 " + //KFZ mit Kennzeichen W16440 nicht abgestellt  
                " stellen G502K 3  ";
                
                
                Scanner sc = new Scanner(befehl);
                Parkplatz p = new Parkplatz(9);
                
                while(sc.hasNext()) {
                        
                        String command = sc.next();
                        
                        try {
                        	
                        	if (command.equals("stellen")) {
                        		
                        		String knz = sc.next();
                        		int stellplatz =  sc.nextInt();
                        		
                        		if (stellplatz > 0 && stellplatz <= p.stellplaetze()) {
                        			
                        			p.stellen(knz, stellplatz);
                        			
                        		} else {
                        		
                        			System.out.println("Platz mit Index " + stellplatz + " gibt es nicht." );
                        		
                        		}
                        		
                        	} else if (command.equals("entfernen")) {
                        		
                        		String knz = sc.next();
                        		
                        		if(p.istAbgestellt(knz)){
                        			
                        			p.entfernen(knz);
                        			
                        		} else {
                        			
                        			System.out.println("KFZ mit Kennzeichen " + knz + " nicht abgestellt.");
                        			
                        		} 	
                        		
                        	} else if (command.equals("belegt")) {
                        		
                        		p.istBelegt(sc.nextInt());
                        		
                        	}
                        	
                        } catch (StellplatzIndexException e) {
                        	
                        	System.out.println(e.getMessage());
                        	
                        } catch (StellplatzBelegtException e) {
                        	
                        	System.out.println(e.getMessage());
                        	
                        }
                        
                        
                }
                
                System.out.println(p); 
                /*
                * Sollausgabe:
                * 
                * Platz mit Index 5 bereits belegt.
                * KFZ mit Kennzeichen SL105W nicht abgestellt.
                * Platz mit Index 10 gibt es nicht.
                * Platz mit Index 10 gibt es nicht.
                * KFZ mit Kennzeichen W16440 nicht abgestellt.
                * {G502K=3, K345L=1}
                * 10 Stellplätze insgesamt
                * 
                */
                
        }
}