/**
* Testet die Funktionen der gefragten Klassen. Es können neue
* Testfälle hinzugefügt werden. 
*/

import java.util.Iterator;

public class TrainTest {
	public static void main (String [] args) {
		
		Train tgv = new Train(new Locomotive(86, 19.0, 300));
		
		Car pc1 = new PassengerCar(42.0,26.4,54);
		Car pc2 = new PassengerCar(50.0,30.0,66);
		Car pc3 = new PassengerCar(42.0,30.0,56);
		Car dc1 = new DiningCar(42.0,26.4,24,false);
		Car dc2 = new DiningCar(42.0,26.4,24,true);
		
		tgv.add(pc1);
		tgv.add(dc2);
		tgv.add(new PassengerCar(35.0,26.4,32));
		
		
		Car pc4 = new PassengerCar(42.0,26.4,54);
		Car pc5 = new PassengerCar(50.0,30.0,66);
		Car pc6 = new PassengerCar(42.0,30.0,56);
		Car dc3 = new DiningCar(42.0,26.4,24,false);
		Car dc4 = new DiningCar(42.0,26.4,24,true);
		
		Train tgv2 = new Train(new Locomotive(86, 19.0, 300));
		
		tgv2.add(pc4);
		tgv2.add(dc4);
		tgv2.add(new PassengerCar(35.0,26.4,32));
		//tgv2.add(new PassengerCar(35.0,26.4,32));
		
		
		System.out.println(tgv.toString());
		System.out.println(tgv2.toString());
		
		System.out.println(tgv2.equals(tgv));
		
		/* Ausgabe:
		
		Locomotive1: 86.0 19.0, 300
		PassengerCar2: 42.0 26.4, 54
		DiningCar6: 42.0 26.4, 24, geoeffnet
		PassengerCar7: 35.0 26.4, 32
		hat geoeffneten Speisewagen.
		Locomotive13: 86.0 19.0, 300
		PassengerCar8: 42.0 26.4, 54
		DiningCar12: 42.0 26.4, 24, geoeffnet
		PassengerCar14: 35.0 26.4, 32
		hat geoeffneten Speisewagen.
		true
		
		*/
		
		Train ice = new Train(new Locomotive(92, 21.0, 450));
		ice.add(pc2);
		ice.add(dc1);
		ice.add(pc3);
		
		System.out.println(ice.toString());
		/* Ausgabe:
		
		Locomotive15: 92.0 21.0, 450
		PassengerCar3: 50.0 30.0, 66
		DiningCar5: 42.0 26.4, 24, geschlossen
		PassengerCar4: 42.0 30.0, 56
		
		*/
		
		Iterator<Car> iter = ice.iterator();
		
		iter.remove();
		
		System.out.println(iter.next()); iter.remove();
		System.out.println(iter.next()); iter.remove();
		System.out.println(iter.next());
		
		System.out.println(ice);
		
		/*
		
		PassengerCar3: 50.0 30.0, 66
		DiningCar5: 42.0 26.4, 24, geschlossen
		PassengerCar4: 42.0 30.0, 56
		Locomotive15: 92.0 21.0, 450
		PassengerCar4: 42.0 30.0, 56
		
		*/
		
	}
}
