public class Tree {
	
	private String indent = "";
	
	public void execute(DirectoryEntry de) {
	
		System.out.println(indent + (de instanceof Directory?"+":"") + de.name());
		
		if (de instanceof Directory) {
		
			String lastIndent = indent;
			indent += "   ";
			
			for (DirectoryEntry e: ((Directory)de).list()) {
			
				execute(e);
			
			} 
			
			indent = lastIndent;
			
		
		}
	
	}
	
}
