import java.util.Scanner;
import java.util.HashMap;

/**  
* Hauptprogramm, testet Ihre Lösung. 
* 
* Erstellen Sie die Klassen File, Directory, die das Interface 
* DirectoryEntry implementieren, sowie die Klassen Find und Tree, die
* zwei spezielle Operationen darstellen. 
*/  
public class Main 
{
	public static void main(String[] args) 
	{
		
		Directory root = new Directory("root");
		Directory sub = new Directory("html");
		Directory sub2 = new Directory("cgi");
		
		File f1 = new File("test.txt");
		File f2 = new File("index.html");
		File f3 = new File("test.sh");
		File f4 = new File("test.pl");
		File f5 = new File("test.py");
		
		f1.setContent("");
		f2.setContent("bin ein html file");
		f3.setContent("bin ein shell script");
		f4.setContent("bin ein perl script");
		f5.setContent("bin ein pyhton script");
		
		Find fo1=new Find("index");
		Find fo2=new Find("html");
		Tree fo3=new Tree();
		
		root.add(f1);
		root.add(sub);
		root.add(sub2);
		
		sub.add(f2);
		sub2.add(f3);
		sub2.add(f4);
		sub2.add(f5);
		
		Scanner sc = new Scanner(System.in);
		
		DirectoryEntry current = root;
		
		HashMap<String, Factory> commandMap = new HashMap<String, Factory>();
		commandMap.put("tree", new TreeFactory());
		commandMap.put("find", new FindFactory());
		commandMap.put("cd", new ChangeFactory());
		
		while(sc.hasNext()) {
			
			String command = sc.next();
			
			current = commandMap.get(command).create(sc).execute(current);
			
		}
        	
        }
}

